#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#include <signal.h>
#include "globals.h"
#include "init.h"
void render()
{
static int frame=0;
int a,b;
int c=0;
int d=0;
char ships[2][9][3]={{",^,","_O-","-o-"," + ","<O>","+x+","*:*",":':","' '"},
	{".-.","-O_","/o\\"," x ","<+>","-x-","O:O","|,|","'' "}};
int colors[9]={1,2,4,1,3,7,7,3,1};
wclear(aliens);
wattrset(aliens,COLOR_PAIR(1));
left=1;
right=-1;
bottom=-1;
shipnum=0;
for (a=0;a<11;a++) {
	lowest_ship[a]=-1;
}
frame++;
for (b=0;b<10;b++) {
for (a=0;a<11;a++) {
	if ((b%2)==0)
	{
		d=enemy[c][a];
		if (d!=0) {
			lowest_ship[a]=b;
			shipnum++;
			if (left==1 || -a>left) {left=-a;}
			if (right==-1 || a>right) {right=a;}
			if (bottom==-1 || c>bottom) {bottom=c;}
			wattrset(aliens,COLOR_PAIR(colors[d-1]));
			waddch(aliens,ships[frame%2][d-1][0]);
			waddch(aliens,ships[frame%2][d-1][1]);
			waddch(aliens,ships[frame%2][d-1][2]);
			if (d>4) {enemy[c][a]=(d+1)%9;}
		} else {waddstr(aliens,"   ");}
	} else {
		waddstr(aliens,"   ");
	}
}
if ((b%2)==0) {c++;} 
}
bottom=bottom*2;
left=left*3;
right=right*3;
wclear(bunkers);
wattrset(bunkers,COLOR_PAIR(5));
for (b=0;b<BUNKERHEIGHT;b++) {
	for (a=0;a<BUNKERWIDTH;a++) {
		if (bunker[b][a]==1) {waddch(bunkers,'#');} else {waddch(bunkers,' ');}
	}	
} 
wrefresh(aliens);
wrefresh(bunkers);
}
void init_ncurses()
{
(void) signal(SIGINT,finish);
(void) initscr();
keypad (stdscr,TRUE);
(void) nonl();
(void) cbreak();
(void) noecho();
start_color();
init_pair(1,COLOR_RED,COLOR_BLACK);
init_pair(2,COLOR_GREEN,COLOR_BLACK);
init_pair(3,COLOR_YELLOW,COLOR_BLACK);
init_pair(4,COLOR_BLUE,COLOR_BLACK);
init_pair(5,COLOR_CYAN,COLOR_BLACK);
init_pair(6,COLOR_MAGENTA,COLOR_BLACK);
init_pair(7,COLOR_WHITE,COLOR_BLACK);
}
void init_game()
{
int level[5][12]={{	1,1,1,1,1,1,1,1,1,1},
		   {	2,2,2,2,2,2,2,2,2,2},
		   {	2,2,2,2,2,2,2,2,2,2},
		   {	3,3,3,3,3,3,3,3,3,3},
		   {	3,3,3,3,3,3,3,3,3,3}};

char bunkerd[BUNKERHEIGHT][BUNKERWIDTH]={	
  "        ###                 ###                 ###                 ###         ",
  "       #####               #####               #####               #####        ",
  "      #######             #######             #######             #######       ",
  "      ##   ##             ##   ##             ##   ##             ##   ##       "};
// 12345678901234567890123456789012345678901234567890123456789012345678901234567890
// 80 characters wide

	int a,b;
	int c=0;
	int d=0;
	for (a=0;a<12;a++) {
		for (b=0;b<5;b++) {
			enemy[b][a]=level[b][a];
		}
	}
	for (a=0;a<BUNKERWIDTH;a++) {
		for (b=0;b<BUNKERHEIGHT;b++) {
			if(bunkerd[b][a]=='#')
				bunker[b][a]=1;
			else
				bunker[b][a]=0;
		}
	}
	aliens=newpad(10,33);
	leer=newpad(10,33);
	wclear(leer);
/*	wattrset(aliens,COLOR_PAIR(1));
	for (b=0;b<10;b++) {
	for (a=0;a<11;a++) {
			if ((b%2)==0) 
			{
				d=enemy[c][a];
				if (d!=0) {
					wattrset(aliens,COLOR_PAIR(colors[d-1]));
					waddch(aliens,ships[a%2][d-1][0]);
					waddch(aliens,ships[a%2][d-1][1]);
					waddch(aliens,ships[a%2][d-1][2]);
					if (d>4) {d=(d+1)%9;}
				} else {waddstr(aliens,"   ");}
			} else {
				waddstr(aliens,"   ");
			}
		}
		if ((b%2)==0) {c++;}
	}
	wrefresh(aliens);*/
	bunkers=newpad(BUNKERHEIGHT,BUNKERWIDTH);
	render();
	
        player=newpad(1,5);
	
        wattrset(player,COLOR_PAIR(3));
        waddch(player,'/');waddch(player,'-');waddch(player,'^');waddch(player,'-');waddch(player,'\\');
        wrefresh(player);
	shot=newpad(1,1);
	wattrset(shot,COLOR_PAIR(7));
	waddch(shot,'!');
	for (a=0;a<500;a++) {
		alienshotx[a]=0;
		alienshoty[a]=0;
	}
	alienshotnum=1;
	alienshotx[0]=5;
	alienshoty[0]=1;
	alienshot=newpad(1,1);
	wattrset(alienshot,COLOR_PAIR(5));
	waddch(alienshot,':');
}
void init()
{
	init_ncurses();
	init_game();
	width=11;
	height=5;
}
static void finish(int sig)
{
	endwin();
	version();
	exit(0);
}
